--
-- ==== Plague Knight ====
-- == By TehRealSalt ==
--
-- defs.lua: Freeslots and basic definitions
--

freeslot(
	"SPR2_BBRS",
	"SPR2_THWG",
	"SPR2_THWA",
	"SPR2_DJMP",
	"SPR2_PKCR",
	"SPR2_DNCS",
	"SPR2_DNCL",

	"S_PLAY_PLAGUEBURST",
	"S_PLAY_PLAGUETHROWGROUND",
	"S_PLAY_PLAGUETHROWAIR",
	"S_PLAY_PLAGUEDOUBLEJUMP",
	"S_PLAY_PLAGUECROUCH",

	"S_PLAY_PLAGUEIDLE1",
	"S_PLAY_PLAGUEIDLE2",
	"S_PLAY_PLAGUEIDLE3",
	"S_PLAY_PLAGUEIDLE4",
	"S_PLAY_PLAGUEIDLE5",
	"S_PLAY_PLAGUEIDLE6",

	"S_PLAY_PLAGUEDANCESTART",
	"S_PLAY_PLAGUEDANCELOOP",

	"MT_PLAGUE_BOMB",
	"S_PLAGUE_BOMB",
	"SPR_PKBM",

	"MT_PLAGUE_EXPLOSION",
	"S_PLAGUE_EXPLOSION1",
	"S_PLAGUE_EXPLOSION2",
	"S_PLAGUE_EXPLOSION3",
	"S_PLAGUE_EXPLOSION4",
	"S_PLAGUE_EXPLOSION5",
	"S_PLAGUE_EXPLOSIONDELAYED",
	"SPR_PKEX",

	"MT_PLAGUE_DEATHEXPLODE",
	"S_PLAGUE_DEATHEXPLODE",
	"SPR_PKDE",

	"MT_PLAGUE_SURGEAURA",
	"S_PLAGUE_SURGEAURA",
	"SPR_SURA",

	"sfx_pkexpl",
	"sfx_pkburs",
	"sfx_pkthro",
	"sfx_pkland",
	"sfx_pkdjmp"
);

spr2defaults[SPR2_BBRS] = SPR2_JUMP;
spr2defaults[SPR2_THWG] = SPR2_FIRE;
spr2defaults[SPR2_THWA] = SPR2_THWG;
spr2defaults[SPR2_DJMP] = SPR2_SPNG;
spr2defaults[SPR2_PKCR] = SPR2_STND;
spr2defaults[SPR2_DNCS] = SPR2_STND;
spr2defaults[SPR2_DNCL] = SPR2_STND;

states[S_PLAY_PLAGUEBURST] = {SPR_PLAY, SPR2_BBRS|FF_ANIMATE, -1, nil, 0, 3, S_PLAY_PLAGUEBURST};
states[S_PLAY_PLAGUETHROWGROUND] = {SPR_PLAY, SPR2_THWG|FF_SPR2ENDSTATE, 3, nil, S_PLAY_STND, 0, S_PLAY_PLAGUETHROWGROUND};
states[S_PLAY_PLAGUETHROWAIR] = {SPR_PLAY, SPR2_THWA|FF_SPR2ENDSTATE, 3, nil, S_PLAY_FALL, 0, S_PLAY_PLAGUETHROWAIR};
states[S_PLAY_PLAGUEDOUBLEJUMP] = {SPR_PLAY, SPR2_DJMP|FF_SPR2ENDSTATE, 3, nil, 0, 0, S_PLAY_SPRING};
states[S_PLAY_PLAGUECROUCH] = {SPR_PLAY, SPR2_PKCR, 2, nil, 0, 0, S_PLAY_STND};

states[S_PLAY_PLAGUEIDLE1] = {SPR_PLAY, SPR2_WAIT|FF_ANIMATE, 4*3, nil, 0, 4, S_PLAY_PLAGUEIDLE2};
states[S_PLAY_PLAGUEIDLE2] = {SPR_PLAY, SPR2_WAIT|FF_ANIMATE, 3*3, nil, 0, 3, S_PLAY_PLAGUEIDLE3};
states[S_PLAY_PLAGUEIDLE3] = {SPR_PLAY, SPR2_WAIT|FF_ANIMATE, 2*3, nil, 0, 2, S_PLAY_PLAGUEIDLE4};
states[S_PLAY_PLAGUEIDLE4] = {SPR_PLAY, SPR2_WAIT|FF_ANIMATE, 3*3, nil, 0, 3, S_PLAY_PLAGUEIDLE5};
states[S_PLAY_PLAGUEIDLE5] = {SPR_PLAY, SPR2_WAIT|FF_ANIMATE, 4*3, nil, 0, 4, S_PLAY_PLAGUEIDLE6};
states[S_PLAY_PLAGUEIDLE6] = {SPR_PLAY, SPR2_WAIT|FF_ANIMATE, 5*3, nil, 0, 5, S_PLAY_STND};

states[S_PLAY_PLAGUEDANCESTART] = {SPR_PLAY, SPR2_DNCS|FF_SPR2ENDSTATE, 3, nil, S_PLAY_PLAGUEDANCELOOP, 0, S_PLAY_PLAGUEDANCESTART};
states[S_PLAY_PLAGUEDANCELOOP] = {SPR_PLAY, SPR2_DNCL, 3, nil, 0, 0, S_PLAY_PLAGUEDANCELOOP};

mobjinfo[MT_PLAGUE_BOMB] = {
	spawnstate = S_PLAGUE_BOMB,
	spawnhealth = 1000,
	radius = 24<<FRACBITS,
	height = 24<<FRACBITS,
	speed = 12<<FRACBITS,
	damage = 3*TICRATE/2,
	flags = MF_SOLID|MF_BOUNCE
};

states[S_PLAGUE_BOMB] = {SPR_PKBM, FF_FULLBRIGHT|FF_ANIMATE, -1, nil, 3, 3, S_NULL};

mobjinfo[MT_PLAGUE_EXPLOSION] = {
	spawnstate = S_PLAGUE_EXPLOSION1,
	spawnhealth = 1000,
	radius = 56<<FRACBITS,
	height = 96<<FRACBITS,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY
};

states[S_PLAGUE_EXPLOSION1] = {SPR_PKEX, FF_FULLBRIGHT, 2, nil, 0, 0, S_PLAGUE_EXPLOSION2};
states[S_PLAGUE_EXPLOSION2] = {SPR_PKEX, FF_FULLBRIGHT|1, 2, nil, 0, 0, S_PLAGUE_EXPLOSION3};
states[S_PLAGUE_EXPLOSION3] = {SPR_PKEX, FF_FULLBRIGHT|2, 2, nil, 0, 0, S_PLAGUE_EXPLOSION4};
states[S_PLAGUE_EXPLOSION4] = {SPR_PKEX, FF_FULLBRIGHT|3, 2, nil, 0, 0, S_PLAGUE_EXPLOSION5};
states[S_PLAGUE_EXPLOSION5] = {SPR_PKEX, FF_FULLBRIGHT|4, 2, nil, 0, 0, S_NULL};
states[S_PLAGUE_EXPLOSIONDELAYED] = {SPR_NULL, 0, 2, nil, 0, 0, S_PLAGUE_EXPLOSION1};

mobjinfo[MT_PLAGUE_DEATHEXPLODE] = {
	spawnstate = S_PLAGUE_DEATHEXPLODE,
	spawnhealth = 1000,
	radius = 16<<FRACBITS,
	height = 48<<FRACBITS,
	dispoffset = 1,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOCLIP
};

states[S_PLAGUE_DEATHEXPLODE] = {SPR_PKDE, FF_FULLBRIGHT|FF_ANIMATE, 24, nil, 7, 3, S_NULL};

-- Contained here for coop bursts
mobjinfo[MT_PLAGUE_SURGEAURA] = {
	spawnstate = S_PLAGUE_SURGEAURA,
	spawnhealth = 1000,
	radius = 12*FRACUNIT,
	height = 24*FRACUNIT,
	dispoffset = 1,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOCLIP
};

states[S_PLAGUE_SURGEAURA] = {SPR_SURA, FF_FULLBRIGHT|FF_ANIMATE, 7, nil, 7, 1, S_NULL};

sfxinfo[sfx_pkburs].caption = "Bomb burst";
sfxinfo[sfx_pkthro].caption = "Bomb throw";
sfxinfo[sfx_pkexpl].caption = "Plague explosion";
sfxinfo[sfx_pkdjmp].caption = "Double jump";
sfxinfo[sfx_pkland].caption = "Landed";

-- DEFINE GLOBAL TABLE
rawset(_G, "Plague", {});

-- Unexposed SRB2 globals
local function UnexposedGlobal(name, value)
	if not (rawget(_G, name))
		rawset(_G, name, value);
	end
end

UnexposedGlobal("MAXPLMOVE", 50);
UnexposedGlobal("ORIG_FRICTION", (0xE8 << (FRACBITS-8)));

-- Plague Knight magic values
Plague.BURSTTHRESHOLD = TICRATE;
Plague.BURSTINVULTIME = 10;
Plague.DEATHTIME = 30;

-- Random helper functions
Plague.OppositeColor = function(player)
	if (player.mo.color >= SKINCOLOR_SUPERSILVER1 and player.mo.color <= SKINCOLOR_SUPERTAN5)
		-- Different bomb burst blinking for the super colors, why not?
		local colorblock = (player.mo.color - SKINCOLOR_SUPERSILVER1) / 5;
		local firstcolor = (colorblock * 5) + SKINCOLOR_SUPERSILVER1;
		local colornum = player.mo.color - firstcolor;

		local opcolorblocks = {
			[0] = 0, -- Silver
			[1] = 3, -- Red
			[2] = 5, -- Orange
			[3] = 1, -- Gold
			[4] = 6, -- Peridot
			[5] = 2, -- Sky
			[6] = 4, -- Purple
			[7] = 8, -- Rust
			[8] = 7, -- Tan
		};

		local opcolorblock = opcolorblocks[colorblock];
		if (opcolorblock == nil)
			opcolorblock = 3;
		end

		local opcolornum = 4 - colornum;

		return (opcolorblock * 5) + SKINCOLOR_SUPERSILVER1 + opcolornum;
	elseif (skins[player.mo.skin].prefoppositecolor != SKINCOLOR_NONE)
	and (player.skincolor == skins[player.mo.skin].prefcolor)
		-- Preferred opposite color
		return skins[player.mo.skin].prefoppositecolor;
	else
		-- Standard opposite color
		return skincolors[player.skincolor].invcolor;
	end
end

--[[
Plague.WaterMomZ = function(momz)
	return FixedDiv(momz, FixedSqrt(3*FRACUNIT))
end
--]]

Plague.ScaleMomZ = function(mo, momz)
	local finalMomZ = momz;

	if (mo.eflags & MFE_UNDERWATER)
		finalMomZ = FixedDiv($1, FixedSqrt(3*FRACUNIT));
	end

	-- This is here for digital empire :)
	local baseGravity = FRACUNIT/2;
	local gameGravity = gravity;

	if (gameGravity != baseGravity)
		if (gameGravity == 0)
			-- cheap dirty trick to prevent divide by 0 :V
			gameGravity = 1;
		end

		local factor = FixedDiv(baseGravity, gameGravity);
		local invert = false;

		if (factor <= 1)
			-- another cheap dirty trick to prevent root domain :VVV
			factor = 2;
		end

		finalMomZ = FixedDiv($1, FixedSqrt(factor));
	end

	return finalMomZ;
end

Plague.ApplyMomZ = function(mo, momz)
	if (mo and mo.valid)
		P_SetObjectMomZ(mo, Plague.ScaleMomZ(mo, momz), false);
	end
end

Plague.CanDance = function(player)
	if (player.powers[pw_carry] == CR_MINECART)
		-- I would LIKE players to dance during this,
		-- but it's one of those circumstances where it overwrites your state every frame,
		-- which means dancing gets stuck on the first frame.
		-- If you like to do hardcode: please never do that because it makes freeslotted SPR2s completely worthless :V
		return false;
	end

	return (player.panim == PA_IDLE);
end

Plague.InDanceState = function(player)
	return (player.mo.state == S_PLAY_PLAGUEDANCESTART
		or player.mo.state == S_PLAY_PLAGUEDANCELOOP);
end

Plague.PlayerIsFriendly = function(player, comparePlayer)
	if not ((player and player.valid)
	and (comparePlayer and comparePlayer.valid))
		// Invalid players?
		return false;
	end

	if (gametyperules & GTR_FRIENDLY)
		// Always true.
		return true;
	end

	if (gametyperules & GTR_TAG)
		// Consider tagged players a different team from un-tagged players.
		return ((player.pflags & PF_TAGIT) == (comparePlayer.pflags & PF_TAGIT));
	end

	if (gametyperules & GTR_TEAMS)
		// Only if you're on the same team.
		return (player.ctfteam == comparePlayer.ctfteam);
	end

	// Always false.
	return false;
end

Plague.MaxBombs = function(player)
	if (player.powers[pw_super])
		return 10; -- bomb rapid fire
	end

	return 3;
end

Plague.AllowAbilities = function(player, stasis, allowinpain)
	if (player.exiting) or (player.pflags & PF_GAMETYPEOVER)
		-- No abilities when you're done
		return false;
	end

	if ((gametyperules & GTR_RACE) and (leveltime < 4*TICRATE))
		-- Not during start countdown
		return false;
	end

	if (player.mo.reactiontime > 0)
		-- Not during post-teleport stasis
		return false;
	end

	if (stasis != nil)
		if (player.pflags & stasis)
			-- Don't allow in this stasis type
			return false;
		end

		if (player.powers[pw_nocontrol])
			if ((stasis != PF_JUMPSTASIS) or (player.powers[pw_nocontrol] & (1<<15)))
				return false;
			end
		end
	end

	if (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
		-- No abilities during transform
		return false;
	end

	if (player.powers[pw_carry] or player.mo.plague.prevcarry)
		-- No abilities when in a special carry state
		return false;
	end

	if (allowinpain)
		if (P_PlayerInPain(player) and player.mo.plague.paindelay)
			-- Don't allow this ability in inital frames of pain state
			return false;
		end
	else
		if (P_PlayerInPain(player))
			-- Don't allow this ability in pain state
			return false;
		end
	end

	if (CBW_Battle)
		-- Battle mod specific
		if (CBW_Battle.PreRoundWait())
		or (player.lockmove)
		or (player.iseggrobo)
		or (player.eggrobo_transforming)
		or (player.isjettysyn)
			return false;
		end
	end

	if (player.mo.tether != nil)
		-- Tether specific
		if (player.mo.tether.teleportTo and player.mo.tether.teleportTo.valid)
		or (player.mo.tether.respawnDelay > 0)
		or (player.mo.tether.wasTeleporting == true)
			return false;
		end
	end

	return true;
end

Plague.DoesntHaveFlag = function(player)
	-- Like plagueAllowAbilities, but only for disabling mobility options, not attack options
	if (player.gotflag)
		return false
	end

	if (CBW_Battle)
		if (player.gotcrystal)
			return false
		end
	end

	return true
end

Plague.Reset = function(player)
	local thokked = (player.pflags & PF_THOKKED);
	P_ResetPlayer(player);
	player.pflags = $1 | thokked;
end
